
Vouchwell
io.github.VouchwellPublished by GitHub account Vouchwellv0.8.0Updated Oct 24, 2026
Read, verify and export a tamper-evident log of what an AI agent did. Read-only.
Overview
Lets an assistant run other MCP servers through a policy gate that blocks or escalates risky tool calls and writes verifiable receipts.
- What you can do
- Vouchwell proxies MCP servers so every tool call is checked against a policy before it runs and every decision — allowed, blocked or escalated to a human — is written to an append-only log (R5, R7). Receipts are Ed25519-signed over an RFC 8785 canonical form, hash-chained, and anchored in an RFC 6962 Merkle log, with arguments stored as salted commitments (R11, R12, R13, R15). Commands cover initialising a log and policy, inspecting it, verifying it end to end, producing inclusion proofs, exporting evidence bundles for third parties, and shredding payload commitments (R17).
- When to use it
- Use it when agents spend money, send mail or touch customer data and you need decisions gated before execution plus evidence a third party can verify without trusting your own logs (R3, R4, R10). It suits teams that want policy enforcement and auditability around existing MCP servers, and CI checks that fail when a log has been altered (R18). It is not a substitute for covering every path an agent can take to an API (R20).
- Requirements
- Runs as a local stdio process on the desktop, installed from the npm package vouchwell (npm install -g vouchwell, then vw init) (R5). No authentication, environment variables or headers are declared. Optional hub features (vw remote add, vw push, vw cosign) require connecting to a hub (R17).
Installation
In SourceWeft
- Open Vouchwell in the dashboard and add it to a workspace.
- Enable the server for the chats that should use its tools.
Desktop only via STDIO. STDIO servers start a local process, so they need the SourceWeft desktop host.
Other MCP clients
Follow the launch instructions in the repository.
README
vouchwell
Tamper-evident receipts for AI agent actions.
Your agents spend money, send mail, and touch customer data. When something goes wrong, "our logs say it didn't" is not an answer — your logs are a text file you can edit.
Vouchwell makes every agent action policy-gated before it runs and cryptographically provable afterwards.
Then wrap any MCP server — this is the whole integration:
Every tool call now hits your policy first, and every decision — allowed, blocked, or escalated to a human — lands in an append-only log an outside party can verify without trusting you.
Why it is not just logging
Everyone is building agent observability — dashboards you have to take on faith. Vouchwell builds agent evidence: a record whose integrity a third party can check independently, using nothing but the file you hand them.
- Signed — Ed25519 over an RFC 8785 canonical form.
- Chained — each receipt commits to its predecessor's hash.
- Tree-anchored — RFC 6962 Merkle log, the construction Certificate Transparency uses. Verified against the published CT reference vectors.
- Sealed — arguments are salted commitments, not payloads. Destroy the salts and those payloads become permanently unopenable while every proof still verifies, so a GDPR erasure does not gut the audit trail.
Commands
vw verify exits non-zero when a log has been altered — put it in CI.
What it does not do
- It cannot prove an action it never saw. An agent with a second, unwrapped path to the same API leaves no receipt.
- The cryptography has not been reviewed by anyone independent. It is pinned to published RFC 6962 and RFC 8032 vectors rather than only to itself, but that is not the same thing.
Full threat model: https://github.com/vouchwell/vouchwell/blob/main/docs/THREAT-MODEL.md
Part of Vouchwell
Full documentation: https://github.com/vouchwell/vouchwell
Apache-2.0. The format, the verifier and the CLI are open and stay open: evidence you cannot verify without a vendor's permission is not evidence.
Source: packages/cli/README.md at commit ec9d07b
Tools
0Version history
1- v0.8.0LatestOct 14, 2026
Score
40% of the applicable checks met
How complete this listing is, computed from the registry entry, the endpoint and public sources. Not a rating of the server and not a statement that it is safe or working today: reachability is a dated check, and no installs or reviews go into the score.
- Reached in the last 30 days25 pts
Keep the endpoint answering the MCP handshake; SourceWeft probes it every 30 days.
- Auth declared10 pts
Declare the credential headers in the registry entry, or keep the endpoint answering the probe so its auth can be classified.
- Tools listed15 pts
Answer tools/list without a credential, or ship a package that starts in a sandbox without one.
- DescriptionRequired15 pts
- Logo10 pts
- Documentation15 pts
- License10 pts
Declare a license in the repository or the registry entry.